#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>

static void error_fatal (char *message);

/* Program demonstrira moguci race condition. Program kreira dete proces i
   potom oba procesa ispisuju poruku nebaferovano na standardni izlaz. */
int main (int argc, char **argv){
  pid_t pid;			/* Identifikator procesa. */

  if ((pid = fork ()) < 0)
    error_fatal (argv[0]);
  /* Dete proces stampa poruku na standardni izlaz.*/
  else if (pid == 0){
    char *message = "Hello world from child!\n"; // Poruka koja ce biti odstampana.
    
    /* Iskljucuje se baferovanje na standardnom izlazu. */
    if (setvbuf (stdout, NULL, _IONBF, 0) < 0)
      error_fatal ("setvbuf in child error");
    
    /* Dete proces stampa poruku karakter po karakter na standardni izlaz. */
    for (; *message != 0;)
      putchar (*message++);
  }
  /* Roditeljski proces stampa poruku na standardni izlaz.*/
  else {
    char *message = "Hello world from parent!\n"; // Poruka koja ce biti odstampana.
    
    /* Iskljucuje se baferovanje na standardnom izlazu. */
    if (setvbuf (stdout, NULL, _IONBF, 0) < 0)
      error_fatal ("setvbuf in parent error");
    
    /* Roditeljski proces stampa poruku karakter po karakter na standardni izlaz.*/
    for (; *message != 0;)
	putchar (*message++);
  }
  
  /* Zavrsava se program. */
  exit (EXIT_SUCCESS);
}

static void error_fatal (char *message){
  perror (message);
  exit (EXIT_FAILURE);
}
